v 2.1.0 [26-Dic-2023]
    - Mejora: Se agrega filtro por día en facturas.


v 2.0.9 [20-Dic-2023]
    - Fix: Issue 98 y 107


v 2.0.8 [30-Oct-2023]
---------------------
    - Fix: Permitir generar CFDI de egreso para facturas globales sin datos globales.
    - Fix: Permitir cambiar la zona horaria para cuando se usa en servidor.

Es necesario hacer una migración:
```
cd /opt/empresa-libre

git pull origin master

cd source/app/models

python main.py -bk

python main.py -m -r RFC
```


v 2.0.7 [06-Ju1-2023]
---------------------
    - Fix: En tasa de retención de un Resico a una Persona Moral.


v 2.0.6 [14-Jun-2023]
---------------------
    - Fix: Al generar complementos de pago con facturas con retención de impuestos.


v 2.0.5 [05-Jun-2023]
---------------------
    - Fix: Al generar complementos de pago con facturas con varios impuestos.
    - Fix: ticket #103, hay que usar {receptor.correo_facturas} y {receptor.telefonos}


v 2.0.2 [01-Abr-2023]
---------------------
    - Fix: Obtener la clave del sat al facturar por lote.


v 2.0.1 [29-Mar-2023]
---------------------
    - Fix ticket #97

Es necesario hacer una migración:
```
cd /opt/empresa-libre

git pull origin master

cd source/app/models

python main.py -bk

python main.py -m -r RFC
```


v 2.0.0 [08-Ene-2023]
----------------------
    - Liberamos para todos la versión CFDI 4.0
    - **IMPORTANTE** NO intentes timbrar si **antes** no has validado en nuestro demo que puedes timbrar tus CFDIs habituales.

* IMPORTANTE:

Es necesario hacer una migración:

```
cd /opt/empresa-libre

git pull origin master

cd source/app/models

python main.py -bk

python main.py -m -r RFC
```

Y reiniciar todo. IMPORTANTE: dependiendo desde que versión actualices, tal vez debas de hacer algún prodecimiento extra. Siempre revisa este historial.


v 2.0.0 [31-Mar-2022]
----------------------
    - Primera versión de timbrado con CFDI4
    - **IMPORTANTE** NO intentes timbrar si **antes** no has validado en nuestro demo que puedes timbrar tus CFDIs habituales.


v 1.47.0 [28-Mar-2022]
----------------------
    - Mejora: Soporte basico para complemento Comercio Exterior.


v 1.46.5 [10-Mar-2022]
----------------------
    - Error: Al timbrar nómina con Comercio Digital


v 1.46.4 [18-Feb-2022]
----------------------
    - Error: Issue #54


v 1.46.3 [15-Feb-2022]
----------------------
    - Error: Issue #53


v 1.46.2 [31-Ene-2022]
----------------------
    - Error: Al generar Carta Porte sin remolque.
    - Error: Al cancelar con Finkok.


v 1.46.1 [29-Ene-2022]
----------------------
    - Error: Issue #49
    - Mejora: Agregar validación para distancia en origen de Carta Porte.


v 1.46.0 [27-Ene-2022]
----------------------
    - Mejora: Issue #45
    - Mejora: Agregar tipos de persimos SCT para Carta Porte
    - Mejora: Buscar estado y municipio por CP en Carta Porte


v 1.45.4 [25-Ene-2022]
----------------------
    - Error: Al timbrar carta porte.
    - Error: Al cancelar con Comercio Digital.
    - Error: Issue #42
    - Mejora: Issue #44

* IMPORTANTE: Es necesario subir de nuevo tus certificados de sello, **solo** si timbras con Comercio Digital.


v 1.45.3 [23-Ene-2022]
----------------------
    - Error: El enviar por correo CFDI de pago. Ticket #40


v 1.45.2 [21-Ene-2022]
----------------------
    - Error: Al cancelar un CFDI


v 1.45.1 [20-Ene-2022]
----------------------
    - Error: Al enviar correos con la nueva configuración


* IMPORTANTE: Revisa tu configuración de correo para verificar que todo funcione.


v 1.45.0 [20-Ene-2022]
----------------------
    - Importar Carta Porte desde archivo JSON


v 1.44.2 [19-Ene-2022]
----------------------
    - Agregar opción STARTTLS que requieren algunos servidores de correo

* IMPORTANTE: Revisa tu configuración de correo para verificar si tienes que usar esta opción.


v 1.44.1 [19-Ene-2022]
----------------------
    - Correciones en generación de Carta Porte v2.0
    - Plantilla para representación impresa de Carta Porte v2.0


v 1.44.0 [10-Ene-2022]
----------------------
    - Soporte para Carta Porte v2 con CFDI 3.3
    - Soporte para el nuevo esquema de cancelación del SAT

* IMPORTANTE:

Es necesario hacer una migración:

```
cd /opt/empresa-libre

git pull origin master

cd source/app/models

python main.py -bk

python main.py -m -r RFC
```


v 1.43.0 [12-Dic-2021]
----------------------
    - Soporte para entradas de almacen.
    - Soporte para multi almacen.
    - Soporte para regenerar un ticket.
    - Soporte para movimientos entre almacenes
    - Consulta en SAT para estatus de nómina

* IMPORTANTE:

Instalar nuevo requerimiento:

```
pip install segno
```

Es necesario hacer una migración:

```
git pull origin master

cd source/app/models

python main.py -bk

python main.py -m -r RFC
```

v 1.42.2 [14-Sep-2021]
----------------------
    - Los productos pueden no llevar ningún impuesto.


v 1.42.1 [31-May-2021]
----------------------
    - Error - Ticket #5


v 1.42.0 [24-May-2021]
----------------------
    - Opción para que solo un admin pueda cancelar.


v 1.41.4 [13-Abr-2021]
----------------------
    - Error - Ticket #4


v 1.41.3 [12-Feb-2021]
----------------------
    - Error - Ticket #3


v 1.41.2 [12-Feb-2021]
----------------------
    - Error - Ticket #2


v 1.41.1 [11-Feb-2021]
----------------------
    - Error - Ticket #1


v 1.41.0 [10-Feb-2021]
----------------------
    - Importar clientes desde archivo CSV


v 1.40.1 [09-Feb-2021]
----------------------
    - Fix #422


v 1.40.0 [05-ene-2021]
----------------------
    - Error: Al parsear XML en Python 3.9+
    - Mejora: Agregar versión de Empresa Libre a plantilla.
    - Mejora: Sellado en memoria
    - Mejora: Se agrega un segundo PAC y se refactoriza el timbrado.

* **IMPORTANTE**

Es necesario seguir una serie de pasos **obligatorios** para migrar a esta
versión, **no continues hasta seguir paso a paso** estas instrucciones.
**Antes** de comenzar ten a la mano tus certificados de sello para timbrar, es
necesario subirlos de nuevo. **NO actualices si no tienes tus certificados**
con su respectiva contraseña, te quedarás sin poder timbrar.

Estas instrucciones solamente aplican para la maquina virtual con Ubuntu Server,
la ultima y única versión sobre la que se dará soporte.

1. Entra a la parte administrativa y toma de tus credenciales de timbrado en el
menú "Emisor" ficha "Otros Datos", usuario y token de timbrado.
1. Agregar nuevos requerimientos `sudo apt install pkgconf libxml2-dev libxmlsec1-dev libxmlsec1-openssl`
1. Agregar nuevo requerimiento `pip install --user xmlsec`
1. Entrar a la carpeta del sistema: `/opt/empresa-libre`
1. Actualizar `git pull origin master`
1. Entrar a `source/app/controllers/pacs/comerciodigital` y copiar `conf.py.example` a `conf.py`
1. Entrar a `source/app/controllers/pacs/finkok` y copiar `conf.py.example` a `conf.py`
1. Agregar la variable `TOKEN = ''` al archivo `source/app/conf.py` mira el archivo de ejemplo en el mismo directorio.
1. Reiniciar el servicio: `sudo systemctl restart empresalibre`
1. Si no ves los cambios descritos a continuación, fuerza el refresco de tu navegador, generalmente con **CTRL+F5**
1. Sube de nuevo tus certificados en el menú "Emisor" ficha "Certificado".
1. Ve al menú "Opciones", ficha "Otros".
1. Selecciona tu PAC, si tu usuario es un correo electrónico, invariablemente
debes seleccionar Finkok. Si tienes duda ponte en contacto con nosotros.
1. Establece las credenciales del punto 1.
1. Guarda los datos.


v 1.39.1 [17-sep-2020]
----------------------
    - Error: Esquema para complemento IEDU


v 1.39.0 [25-ago-2020]
----------------------
    - Mejora: Consulta de las facturas de pago en el SAT
    - Mejora: Mostrar totales en nómina
    - Mejora: Mostrar totales por cantidad al facturar
    - Mejora: Validar líneas con importe cero antes de facturar
    - Error: Validaciones de namespace en CFDI de nómina por parte del PAC


v 1.38.1 [30-mar-2020]
----------------------
    - Error: En nómina al timbrar asimilados


v 1.38.0 [08-mar-2020]
----------------------
    - Mejora: Factura global por ticket o nota
    - Error: Al generar algunos PDFs


v 1.37.0 [02-mar-2020]
----------------------
    - Mejora: Soporte para complemento Leyendas Fiscales

* IMPORTANTE:

Es necesario hacer una migración, y agregar los campos necesarios para mostrar
las leyendas, mira la carpeta pública con la plantilla de ejemplo.
```
git pull origin master

cd source/app/models

python main.py -bk

python main.py -m -r RFC
```


v 1.36.0 [25-feb-2020]
----------------------
    - Mejora: Permitir ver a usuarios todos los documentos


v 1.35.0 [24-feb-2020]
----------------------
    - Mejora: Filtrado de documentos por sucursal


v 1.34.1 [09-feb-2020]
----------------------
    - Error: Al timbrar nómina de asimilados


v 1.34.0 [29-ene-2020]
----------------------
    - Error: Al timbrar nómina


v 1.33.2 [27-ene-2020]
----------------------
    - Se actualizan métodos de pago en catálogos del SAT

* IMPORTANTE:
Es necesario actualizar los catálogos del SAT
```
git pull origin master

cd source/app/models

python main.py -bk

python main.py -us
```


v 1.33.0 [22-ene-2020]
----------------------
    - Mejora: Cambio del mensaje para cuando se intenta dar de alta un cliente ya existente.
    - Mejora: Solo los admins pueden ver la nómina.
    - Se agrega un segundo PAC
    - Se actualizan los catálogos del SAT

* IMPORTANTE:
Es necesario actualizar los catálogos del SAT
```
git pull origin master

cd source/app/models

python main.py -bk

python main.py -us
```


v 1.32.0 [05-ene-2020]
----------------------
    - Mejora: Recuperar facturas no aceptadas para cancelación por el receptor


v 1.31.2 [28-oct-2019]
----------------------
    - Error: Al generar PDF con tags en las series


v 1.31.1 [28-ago-2019]
----------------------
    - Error: Al agregar nuevo impuesto #369


v 1.31.0 [23-abr-2019]
----------------------
    - Error: Validar cantidad o valor unitario cero en tickets
    - Mejora: Envío de nómina por correo al empleado


v 1.30.0 [24-mar-2019]
----------------------
    - Mejora: Se actualizan los catálogos de Nómina

* IMPORTANTE:
Es necesario realizar una migración, después de actualizar.

```
git pull origin master

cd source/app/models

python main.py -bk

python main.py -m
```


v 1.29.0 [08-mar-2019]
----------------------
    - Error: Al mostrar detalle en facturas importadas #343
    - Mejora: Editar la descripción de un movimiento bancario.


v 1.28.2 [04-mar-2019]
----------------------
    - Error: Al enviar facturas de pago


v 1.28.1 [04-mar-2019]
----------------------
    - Error: Al buscar facturas por fechas


v 1.28.0 [17-feb-2019]
----------------------
    - Mejora: Manejo de empaques para mensajeria
    - Mejora: Usar concepto personalizado en deducciones de nómina 004 Otros
    - Mejora: Búsqueda en notas
    - Mejora: Soporte para el complemento de Divisas
    - Mejora: Descarga de nómina en lote

* IMPORTANTE:
Es necesario realizar una migración, después de actualizar.

```
git pull origin master

cd source/app/models

python main.py -bk

python main.py -m
```

Es necesario agregar un nuevo requerimiento.

```
sudo pip install cryptography
```

**IMPORTANTE** Si envias tus facturas por correo directamente, es necesario
volver a capturar la contraseña de tu servidor de correo y guardar los datos
nuevamente.


v 1.27.1 [23-ene-2019]
----------------------
    - Error: Al cancelar nómina


v 1.27.0 [17-ene-2019]
----------------------
    - Mejora: Permitir capturar folio manualmente


v 1.26.1 [16-ene-2019]
----------------------
    - Error: Guardar logos de emisor


v 1.26.0 [15-ene-2019]
----------------------
    - Mejora: Generar PDF desde plantilla JSON


v 1.25.0 [07-nov-2018]
----------------------
    - Fix: Al importar días de pago en nómina
    - Fix: Al importar descripción en factura en lote


v 1.24.0 [06-nov-2018]
----------------------
    - Fix: Consulta estatus SAT


v 1.23.0 [30-oct-2018]
----------------------
    - Mejora: Permitir importar CFDI 3.2


v 1.22.0 [25-oct-2018]
----------------------
    - Mejora: Permitir cambiar descripción al facturar en lote


v 1.21.2 [23-oct-2018]
----------------------
    - Error unicode


v 1.21.1 [14-oct-2018]
----------------------
    - Error #307


v 1.21.0 [12-oct-2018]
----------------------
    - Error #287
    - Mejora: Complemento de pago con datos de cuentas

* IMPORTANTE: Es necesario realizar una migración, despues de actualizar.


v 1.20.0 [08-oct-2018]
----------------------
    - Error #295
    - Mejora: Cuentas de banco para clientes

* IMPORTANTE: Es necesario realizar una migración, despues de actualizar.


v 1.19.1 [03-oct-2018]
----------------------
    - Error #291
    - Error al generar PDF de factura de pago con relacionados sin serie
    - Error al relacionar facturas versión 3.2

v 1.19.0 [28-sep-2018]
----------------------
    - Mejora #280
    - Mejora #288
    - Error #290

* IMPORTANTE: Es necesario realizar una migración, despues de actualizar la rama principal.

```
git pull origin master

cd source/app/models

python main.py -bk

python main.py -m
```


v 1.18.0 [27-sep-2018]
----------------------
    - Fix #282 Factura de pago en otras monedas


v 1.17.0 [25-sep-2018]
----------------------
    - Fix - Al generar factura de pago con documentos relacionados en otras monedas
    - Fix - Al generar factura de pago sin serie en documentos relacionados
    - Fix #278

* IMPORTANTE: Es necesario realizar una migración, despues de actualizar la rama principal.

```
git pull origin master

cd source/app/models

python main.py -bk

python main.py -m
```


v 1.16.1 [18-sep-2018]
----------------------
    - Error https://gitlab.com/mauriciobaeza/empresa-libre/issues/268
    - IMPORTANTE: Actualizar si usas cuatro decimales en impuestos


v 1.16.0 [16-sep-2018]
----------------------
    - Se puede editar el saldo de un cliente
    - Se muestra la cantidad de facturas de pago en los movimientos


v 1.15.0 [12-sep-2018]
----------------------
    - Se pueden mover las facturas con doble clic en los movimientos de banco.
    - Fix - Al sumar las facturas en los depósitos
    - Fix - Al importar los pedimentos en facturas por lotes
    - Fix - Al guardar los datos del emisor


v 1.14.0 [10-sep-2018]
----------------------
    - Personalizar plantilla para factura de pago
    - Fix - Mostrar serie y folio capturado para factura de pago
    - Fix - Agregar nueva cuenta de banco


v 1.13.0 [10-sep-2018]
----------------------
    - Cancelar factura de pago

* IMPORTANTE: Es necesario realizar una migración, despues de actualizar la rama principal.

```
git pull origin master

cd source/app/models

python main.py -bk

python main.py -m
```


v 1.12.0 [31-ago-2018]
----------------------
    - Soporte para facturas (complemento) de pago.

* IMPORTANTE: Es necesario realizar una migración, despues de actualizar la rama principal.

```
git pull origin master

cd source/app/models

python main.py -bk

python main.py -m
```

v 1.11.1 [21-ago-2018]
----------------------
    - Fix - Quitar columna en tabla facturaspagos.

* IMPORTANTE: Es necesario realizar una migración, despues de actualizar la rama principal.

```
git pull origin master

cd source/app/models

python main.py -m
```


v 1.11.0 [25-jul-2018]
----------------------
    - Se cambia la forma de consultar los folios restantes. Es indispensable actualizar a esta versión para ver tus timbres restantes.


v 1.10.0 [10-jul-2018]
----------------------
    - Ahora se pueden manejar precios con cuatro decimales.


v 1.9.3 [08-jul-2018]
---------------------
    - Fix: Al refacturar conceptos con descuento


v 1.9.2 [05-jul-2018]
---------------------
    - Fix: Al generar el reporte de facturas en PDF


v 1.9.1 [25-jun-2018]
---------------------
    - Fix: Al mostrar el título de la aplicación
    - Se agrega el registro de acción al borrar una factura


v 1.9.0 [18-jun-2018]
---------------------
    - Se agrega la vista del detalle de facturas
    - Fix: Al timbrar nómina


v 1.8.1 [14-jun-2018]
---------------------
    - Fix: Se agrega una barra de desplazamiento al buscar productos o clientes
    - Se cambia el servidor de consulta de timbres


v 1.8.0 [03-jun-2018]
---------------------
    - Se permiten 4 decimales en Tipo de cambio
    - Se agrega el campo {total_cantidades} al generar el PDF
    - Se agrega opción para generar respaldos de la BD en MV
    - Fix: Al generar con complemento EDU


v 1.7.0 [23-may-2018]
---------------------
    - Se agrega soporte para truncar impuestos locales, para las estulticias de los "ingenieros" de las dependencias de gobierno


v 1.6.1 [09-abr-2018]
---------------------
    - Fix: Nómina con separación


v 1.6.0 [18-feb-2018]
---------------------
    - Facturacion a extranjeros

* IMPORTANTE: Es necesario realizar una migración, despues de actualizar la rama principal.

```
git pull origin master

cd source/app/models

python main.py -m
```

v 1.5.0 [30-ene-2018]
---------------------
    - Timbrado de Nómina

* IMPORTANTE: Es necesario realizar una migración, despues de actualizar la rama principal.

```
git pull origin master

cd source/app/models

python main.py -m
```

v 1.4.0 [01-ene-2018]
---------------------
    - Impresión de tickets

v 1.3.0 [27-Dic-2017]
---------------------
    - Punto de venta

* IMPORTANTE: Es necesario realizar una migración, despues de actualizar la rama principal.

```
git pull origin master

cd source/app/models

python main.py -m
```

v 1.2.0 [18-Dic-2017]
---------------------
* IMPORTANTE: Es necesario actualizar la base de datos, despues de actualizar la rama principal.

```
git pull origin master

cd source/app/models

python main.py -bd
```

v 0.1.0 [26-Oct-2017]
---------------------
    - Generar y timbrar con CFDI 3.3

